disp('read_motion_stratus_06.m')

if hhh<10,
   dfx2=['0',num2str(hhh)];
else
   dfx2=num2str(hhh);
end;

if ddd<10,
   dfx1=['00',num2str(ddd)];
elseif ddd<100,
   dfx1=['0',num2str(ddd)];
else
   dfx1=num2str(ddd);
end;


dfx=[dfx1 dfx2];

dfl=[drive,'\day',dfx(1:3),'\P5_',dfx];
disp(dfl)
flist=fopen(dfl,'r');         %disp(dfl)
if flist>0
    headr=fgetl(flist);           %disp(headr)
    headr=fgetl(flist);
    z=fscanf(flist,'%g,%g,%g,%g,%g,%g,%g',[7,inf]);
else
    disp('file not found')
end;

tm1=z(1,:);
tmotion=tm1;
 if clearit;clear tm1;end;
tmotion=tmotion-tmotion(1);
tmotion=0:1/20:(length(tmotion)-1)/20;
tmotion=tmotion';

%  As mounted:  motion-pak
%  Xm is toward port
%  Ym is toward bow
%  Zm is down

%  We desire the coordinate system such that
%  +X is toward bow
%  +Y is toward port
%  +Z is up
%  +rotation about the x-axis is port up (phi = roll) 
%  +rotation about the y-axis is bow down (theta = pitch)
%  +rotation about the z-axis is bow to port

accx=+z(6,:)./3.75.*9.81;               %forward is positive 
accy=+(z(5,:)-.1)./3.75.*9.81;          %to port is positive
accz=-z(7,:)./3.756.*9.81;              %up is positive

ratex=+z(3,:)/0.025/180*pi;          %port up is positive phi
ratey=+z(2,:)/0.025/180*pi;          %bow down is positive theta
ratez=-z(4,:)/0.025023/180*pi;       %bow to port is positive psi (right-handed)


G=sqrt(mean(accx)^2+mean(accy)^2+mean(accz)^2);

accx=accx';
accy=accy';
ratex=ratex';
ratey=ratey';
ratez=ratez';
tmotion=tmotion';


fclose(flist);

Lenmotion=36000;
%interpolation at 10Hz
saccx=interpft(accx,Lenmotion);ii=find(~isnan(saccx));msaccx=mean(saccx(ii));ii=find(isnan(saccx));saccx(ii)=msaccx;   
saccy=interpft(accy,Lenmotion);ii=find(~isnan(saccy));msaccy=mean(saccy(ii));ii=find(isnan(saccy));saccy(ii)=msaccy;
saccz=interpft(accz,Lenmotion);ii=find(~isnan(saccz));msaccz=mean(saccz(ii));ii=find(isnan(saccz));saccz(ii)=msaccz;
sratex=interpft(ratex,Lenmotion);ii=find(~isnan(sratex));msratex=mean(sratex(ii));ii=find(isnan(sratex));sratex(ii)=msratex;   
sratey=interpft(ratey,Lenmotion);ii=find(~isnan(sratey));msratey=mean(sratey(ii));ii=find(isnan(sratey));sratey(ii)=msratey;
sratez=interpft(ratez,Lenmotion);ii=find(~isnan(sratez));msratez=mean(sratez(ii));ii=find(isnan(sratez));sratez(ii)=msratez;

tmotion=0:1/10:35999/10;tmotion=tmotion';

accx=saccx;
accy=saccy;
accz=saccz;
ratex=sratex;
ratey=sratey;
ratez=sratez;