disp('read_shp_stratus_06.m')
fclose('all');

jd=num2str(ddd);

g=0.0098;							%adiabatic lapse rate
eps_w=0.97;							%emissivity of water
sig_sb=5.67e-8;					%Stefan Boltzmann constant
blk=1;								%10-min index 
jax=1;
jaxx=1;
backchk=0;
clear st1 st2 st3;
jam=hhh;

if jam<10,
   hr=['0',num2str(jam)];
else
   hr=num2str(jam);
end;
%dfl=['/home/jeh/data/P6_' jd hr];

dfl=[drive,'\day',jd,'\P6_' jd hr];
disp(dfl)

flist=fopen(dfl,'r');
if flist>0,   					%if the file exists, 
   dmp=fgets(flist);
   dmp2=fgets(flist);
   while feof(flist)==0,
     st1=fscanf(flist,'%g,%g,%g%*c,%10f%*c,%g,%g,%g,%g,%g,%g,%g,%g,%g,%g,%g,%g,',[17,inf]);
     [nr1,nl1]=size(st1);
     if nr1==17
  	      st2(:,jax:jax+nl1-1)=st1;
       	  jax=jax+nl1;
     else
   	      x=fgets(flist);
	 end;
   end;
else
     st1=ones(17,1681).*NaN;
     st2=ones(17,1680).*NaN;
end;

% tmotion=(0:1/20:71999/20);
tmotion=(0:1/10:35999/10);

%10/23/06 - Correction of the ship sampling error. 
%Before the routine was correcting the cog, sog and lrg in order to have samples of 1800 values(on line 178 and after). 
%The problem was that the original data were 1682 values. Thus
%an error was introduced at the end...
%size(st2) = [17,1682];
%size(st2t) = [1800,17];    AS if we had 30 data/min... 

% tt=0:60/(length(st2)/60):3599;     %true sampling time from the ship (=2.1403 s)
st2t=interpft(st2',1800);       %interpolation by FFT on a 2s sampling time.
st2t=st2t';
jax2=length(st2t);

cog=st2t(5,1:jax2);     %in degrees
sog=st2t(6,1:jax2);     %in knots
lrg=st2t(13,1:jax2);    %in degrees

imu=st2t(15,1:jax2);
imd=st2t(16,1:jax2);
jk=ceil(jax2/30);
st3=zeros(17,jk);
rdcon=pi/180;
st2t(5,1:jax2)=sog.*cos(cog*rdcon);
st2t(6,1:jax2)=sog.*sin(cog*rdcon);
st2t(15,1:jax2)=imu.*cos(imd*rdcon);
st2t(16,1:jax2)=imu.*sin(imd*rdcon);

lrgc=cos(lrg*rdcon);
lrgs=sin(lrg*rdcon);


%ship data rate for the cruise is 28 per minute, BUT we interpolated the
%data to have 30 data / min!
for j=1:jk
   jl=30*(j-1)+1;
   jj=min(jax2-1,30*j);
   if jj<jl,
      jl=jj;
   end
%   st3(:,j)=median(st2(:,jl:jj)')';
   st3(:,j)=median(st2t(:,jl:jj)')';
   lrgcm(j)=median(lrgc(jl:jj));
   lrgsm(j)=median(lrgs(jl:jj));
end;

sogx=st3(5,:);
sogy=st3(6,:);
imux=st3(15,:);
imuy=st3(16,:);

sogm=sqrt(sogx.*sogx+sogy.*sogy)*.514;				%1-min sog, m/s
cogm=mod(atan2(sogy,sogx)/rdcon+360,360);
imum=sqrt(imux.*imux+imuy.*imuy)*.514;				%1-min imet speed, m/s
imdm=mod(atan2(imuy,imux)/rdcon+360,360);
lrgm=mod(atan2(lrgsm,lrgcm)/rdcon+360,360);		%laser ring gyro

gpstim=st3(2,:);

lat=st3(3,:);
bb=floor(lat/100);
glat=(lat-bb*100)/60;
lat=glat+bb;
clear glat bb

lon=st3(4,:);
bb=floor(lon/100);
glon=(lon-bb*100)/60;
lon=glon+bb;
clear glon bb

tsg=st3(7,:);
tss=st3(8,:);
imrh=st3(9,:);
imta=st3(10,:);
imsol=st3(11,:);
imrain=st3(12,:);
odec=st3(14,:);                 %in m/s
imir=st3(17,:);

% if length(gpstim)<60,
%    gpstim=[gpstim (1:(60-length(gpstim))).*0+gpstim(length(gpstim))];
% end;
% if length(lat)<60,
%    lat=[lat (1:(60-length(lat))).*0+lat(length(lat))];
% end;
% if length(lon)<60,
%    lon=[lon (1:(60-length(lon))).*0+lon(length(lon))];
% end;
% if length(tsg)<60,
%    tsg=[tsg (1:(60-length(tsg))).*0+tsg(length(tsg))];
% end;
% if length(tss)<60,
%    tss=[tss (1:(60-length(tss))).*0+tss(length(tss))];
% end;
% if length(imrh)<60,
%    imrh=[imrh (1:(60-length(imrh))).*0+imrh(length(imrh))];
% end;
% if length(imta)<60,
%    imta=[imta (1:(60-length(imta))).*0+imta(length(imta))];
% end;
% if length(imsol)<60,
%    imsol=[imsol (1:(60-length(imsol))).*0+imsol(length(imsol))];
% end;
% if length(imir)<60,
%    imir=[imir (1:(60-length(imir))).*0+imir(length(imir))];
% end;
% 
% if length(imrain)<60,
%    imrain=[imrain (1:(60-length(imrain))).*0+imrain(length(imrain))];
% end;
% if length(imum)<60,
%    imum=[imum (1:(60-length(imum))).*0+imum(length(imum))];
% end;
% if length(imdm)<60,
%    imdm=[imdm (1:(60-length(imdm))).*0+imdm(length(imdm))];
% end;
% if length(odec)<60,
%    odec=[odec (1:(60-length(odec))).*0+odec(length(odec))];
% end;
% if length(cogm)<60,
%    cogm=[cogm (1:(60-length(cogm))).*0+cogm(length(cogm))];
% end;
% if length(sogm)<60,
%    sogm=[sogm (1:(60-length(sogm))).*0+sogm(length(sogm))];
% end;
% if length(cog)<1800,
%    cog=[cog (1:(1800-length(cog))).*0+cog(length(cog))];
% end;
% if length(sog)<1800,
%    sog=[sog (1:(1800-length(sog))).*0+sog(length(sog))];
% end;
% if length(lrg)<1800,
%    lrg=[lrg (1:(1800-length(lrg))).*0+lrg(length(lrg))];
% end;
% 
% if length(gpstim)>60,
%    gpstim=gpstim(1:60);   %GPS time
% end;
% if length(lat)>60,
%    lat=lat(1:60);               %latitude
% end; 
% if length(lon)>60,
%    lon=lon(1:60);            %longitude
% end;
% if length(tsg)>60,
%    tsg=tsg(1:60);          %thermosalinigraph Temperature
% end;
% if length(tss)>60,
%    tss=tss(1:60);           %salinity
% end;
% if length(imrh)>60,
%    imrh=imrh(1:60);        %RH
% end;
% if length(imta)>60,
%    imta=imta(1:60);        %Tair
% end;
% if length(imsol)>60,
%    imsol=imsol(1:60);      %solar incoming
% end;
% if length(imir)>60,
%    imir=imir(1:60);      %solar incoming
% end;
% 
% if length(imrain)>60,
%    imrain=imrain(1:60);     %rain
% end;
% if length(imum)>60,
%    imum=imum(1:60);        %mean wind
% end;
% if length(imdm)>60,
%    imdm=imdm(1:60);        %wind direction
% end;
% if length(odec)>60,
%    odec=odec(1:60);        %speed of ship relative to water.
% end;
% if length(cog)>1800,
%    cog=cog(1:1800);       %Gps course
% end;
% if length(sog)>1800,
%    sog=sog(1:1800);        %GPS speed over ground
% end;
% if length(lrg)>1800,
%    lrg=lrg(1:1800);         %heading (Laser Ring Gyro)
% end; 

for ii=2:length(lrg),
   if lrg(ii)==0,
      lrg(ii)=lrg(ii-1);
   end;
end

shead=(1:length(tmotion)).*0;
chead=(1:length(tmotion)).*0;

shead(1)=sin(lrg(1)./180.*pi);     %can use also unwrap function to avoid heading problem between 360 and 0 deg.
chead(1)=cos(lrg(1)./180.*pi);

qq=2;

for pp=2:length(tgyro)-1;
   while tgyro(pp) >= tmotion(qq),
%      shead(qq)=(sin(lrg(pp+1)./180.*pi)-sin(lrg(pp)./180.*pi))/(tgyro(pp+1)-tgyro(pp))*(tgyro(pp)-tmotion(qq))+sin(lrg(pp)./180.*pi);
%      chead(qq)=(cos(lrg(pp+1)./180.*pi)-cos(lrg(pp)./180.*pi))/(tgyro(pp+1)-tgyro(pp))*(tgyro(pp)-tmotion(qq))+cos(lrg(pp)./180.*pi);
      shead(qq)=(sin(lrg(pp-1)./180.*pi)+sin(lrg(pp)./180.*pi)+sin(lrg(pp+1)./180.*pi))./3;
      chead(qq)=(cos(lrg(pp-1)./180.*pi)+cos(lrg(pp)./180.*pi)+cos(lrg(pp+1)./180.*pi))./3;
      qq=qq+1;
   end;
end;

for ii=2:length(chead),
   if chead(ii)==0,
      chead(ii)=chead(ii-1);
   end;
   if shead(ii)==0,
      shead(ii)=shead(ii-1);
   end;
end;

heading=mod(atan2(shead,chead).*180./pi+360,360);

sodecx=odec.*cos(lrg./180.*pi);
sodecy=odec.*sin(lrg./180.*pi);
if clearit
clear ii qq pp tmotion tgyro
clear x vul uul tzilch sul st3 st2 st1 sogy sogx sig_sb Tul Tll Rtul Rtll Rsul Rsll
clear Rlul Rlll rdcon prtit prt_it plotit nr1 npz np nl1 lrgsm lrgs lrgcm lrgc jl jk jj 
clear jd jaz jaxx jax jam jade jad j_st j_en j imuy imux hul hr hll g flist imu imd
clear f eps_w dfl dmp2 dmp blk backchk ans
end;


